/**
 * @license Copyright (c) 2013, CKSource - Frederico Knabben
 * For licensing, see LICENSE
 */

"use strict";

var config = require("configuration-processor").configurationProcessor,
    http = require("http"),
    IncomingMessage = require(__dirname + "/../Incoming"),
    Request; // constructor, function

/**
 * @auguments Bender/HttpServer/Message/Incoming
 * @constructor
 * @param {Date} date
 * @param {http/IncomingMessage} request
 */
Request = function (date, request) {
    IncomingMessage.call(this, date);

    this.request = config.assertInstanceOf(http.IncomingMessage, request);
};
Request.prototype = Object.create(IncomingMessage.prototype);

Object.defineProperties(Request.prototype, {
    pathname: {
        /**
         * @return {string}
         */
        get: function () {
            return this.request.url;
        }
    }
});

module.exports = Request;
