/**
 * @license Copyright (c) 2013, CKSource - Frederico Knabben
 * For licensing, see LICENSE
 */

"use strict";

var Message = require(__dirname + "/Message"),
    MessageQueue, // constructor, function
    TaskAggregator = require("flow-inspector").TaskAggregator;

/**
 * @auguments flow-inspector/TaskAggregator
 * @constructor
 */
MessageQueue = function () {
    TaskAggregator.call(this);
};
MessageQueue.prototype = Object.create(TaskAggregator.prototype);

/**
 * @return {array}
 */
MessageQueue.prototype.getSupportedEvents = function () {
    var messageEvents = Message.prototype.getSupportedEvents.call(this);

    return TaskAggregator.prototype.getSupportedEvents.call(this).concat(messageEvents);
};

/**
 * @param {Bender/HttpServer/Message} message
 * @return {bool}
 */
MessageQueue.prototype.isItemAllowed = function (message) {
    return message instanceof Message;
};

module.exports = MessageQueue;
