/**
 * @license Copyright (c) 2013, CKSource - Frederico Knabben
 * For licensing, see LICENSE
 */

"use strict";

var Incoming, // constructor, function
    IncomingMessage = require(__dirname + "/../Message/Incoming"),
    MessageQueue = require(__dirname + "/../MessageQueue");

/**
 * @auguments Bender/HttpServer/MessageQueue
 * @constructor
 */
Incoming = function () {
    MessageQueue.call(this);
};
Incoming.prototype = Object.create(MessageQueue.prototype);

/**
 * @param {Bender/HttpServer/Message/Incoming} message
 * @return {bool}
 */
MessageQueue.prototype.isItemAllowed = function (message) {
    return message instanceof IncomingMessage;
};

module.exports = Incoming;
